<?php

namespace Drupal\legalweb_cloud\Controller;


use Drupal\Core\Block\BlockManagerInterface;
use Drupal\Core\Controller\ControllerBase;
use Drupal\legalweb_cloud\LWCManager;
use Symfony\Component\DependencyInjection\ContainerInterface;

class LWCController extends ControllerBase {

  protected $manager;
  protected $block_manager;

  public function __construct(LWCManager $manager, BlockManagerInterface $block_manager) {
    $this->manager = $manager;
    $this->block_manager = $block_manager;
  }

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('legalweb_cloud.manager'),
      $container->get('plugin.manager.block')
    );
  }

  /**
   * Renders default Imprint Page, if active
   *
   * @return array
   */
  public function imprintBlockPage() {
    return $this->renderBlock('legalweb_cloud_imprint_block');
  }

  /**
   * Renders default Data Privacy Page, if active
   *
   * @return array
   */
  public function dataPrivacyBlockPage() {
    return $this->renderBlock('legalweb_cloud_data_privacy_block');
  }

  /**
   * Returns a rendered version of first instance of block_plugin_id encountered
   *
   * @param $block_plugin_id
   */
  private function renderBlock($block_plugin_id) {
    $block = $this->block_manager->createInstance($block_plugin_id, ['label_display' => '0']);
    return $block->build();
  }


}